"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var execute = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(url, graphQLParams, authToken, transform) {
    var response, data;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return fetch(url, {
              method: "post",
              headers: {
                "Content-Type": "application/json",
                Authorization: "Bearer " + authToken
              },
              body: JSON.stringify(graphQLParams)
            });

          case 2:
            response = _context.sent;
            _context.next = 5;
            return response.json();

          case 5:
            data = _context.sent;
            return _context.abrupt("return", transform(data));

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function execute(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

var getOptionsBySearch = exports.getOptionsBySearch = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(url, query, authToken, search) {
    var operation, graphQLParams, transform;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            operation = "query Search($q:String!) { " + query + " }";
            graphQLParams = {
              operationName: "Search",
              variables: {
                q: search
              },
              query: operation
            };

            transform = function transform(_ref3) {
              var data = _ref3.data;

              return {
                options: data.result.edges.map(function (e) {
                  return {
                    value: e.node.value,
                    label: e.node.label
                  };
                })
              };
            };

            return _context2.abrupt("return", execute(url, graphQLParams, authToken, transform));

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getOptionsBySearch(_x5, _x6, _x7, _x8) {
    return _ref2.apply(this, arguments);
  };
}();

var getOptionByValue = exports.getOptionByValue = function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(url, query, authToken, value) {
    var operation, graphQLParams;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (value) {
              _context3.next = 2;
              break;
            }

            return _context3.abrupt("return", Promise.resolve(null));

          case 2:
            operation = "query Get($id:String!) { " + query + " }";
            graphQLParams = {
              operationName: "Get",
              variables: {
                id: value
              },
              query: operation
            };
            _context3.next = 6;
            return execute(url, graphQLParams, authToken, function (_ref5) {
              var data = _ref5.data;

              var result = data.result;
              return {
                value: result.value,
                label: result.label
              };
            });

          case 6:
            return _context3.abrupt("return", _context3.sent);

          case 7:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function getOptionByValue(_x9, _x10, _x11, _x12) {
    return _ref4.apply(this, arguments);
  };
}();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }