"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var replaceInput = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(input, getByValue, getOptions) {
    var name, value, initial, reactPlaceholder, parentNode;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            name = input.name, value = input.value;
            _context.next = 3;
            return getByValue(value);

          case 3:
            initial = _context.sent;
            reactPlaceholder = input;
            parentNode = input.parentNode;

            if (parentNode) {
              reactPlaceholder = document.createElement("div");
              parentNode.replaceChild(reactPlaceholder, input);
            }

            _reactDom2.default.render(_react2.default.createElement(_Autocomplete2.default, { name: name, initial: initial, getOptions: getOptions }), reactPlaceholder);
            return _context.abrupt("return", { name: name, initial: initial });

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function replaceInput(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = attach;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _reactDom2 = _interopRequireDefault(_reactDom);

var _partial = require("lodash/partial");

var _partial2 = _interopRequireDefault(_partial);

var _graphql = require("./graphql");

var _Autocomplete = require("./Autocomplete");

var _Autocomplete2 = _interopRequireDefault(_Autocomplete);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function attach(graphqlUrl, getQuery, searchQuery, authToken) {
  var flag = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : "data-graphql-autocomplete";
  var afterReplace = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;

  var getByValue = (0, _partial2.default)(_graphql.getOptionByValue, graphqlUrl, getQuery, authToken);
  var getOptions = (0, _partial2.default)(_graphql.getOptionsBySearch, graphqlUrl, searchQuery, authToken);
  document.addEventListener("DOMContentLoaded", function () {
    var _this = this;

    var inputs = document.querySelectorAll("input[" + flag + "]");
    inputs.forEach(function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(i) {
        var _ref3, name, initial;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return replaceInput(i, getByValue, getOptions);

              case 2:
                _ref3 = _context2.sent;
                name = _ref3.name;
                initial = _ref3.initial;

                if (afterReplace) {
                  afterReplace(name, initial);
                }

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, _this);
      }));

      return function (_x6) {
        return _ref2.apply(this, arguments);
      };
    }());
  });
}